//--------------------------------------------------------------------------
// Warp Gun
//
//
//--------------------------------------------------------------------------

datablock EffectProfile(WarpGunTeleportEffect)
{
   effectname = "weapons/Warp_Teleport";
   minDistance = 100.0;
};

datablock EffectProfile(WarpGunSwitchEffect)
{
   effectname = "weapons/sniper_activate";
   minDistance = 2.5;
};

datablock EffectProfile(WarpGunFireEffect)
{
   effectname = "weapons/sniper_fire";
   minDistance = 4.0;
};

datablock EffectProfile(WarpGunFireWetEffect)
{
   effectname = "weapons/sniper_underwater";
   minDistance = 4.0;
};

datablock AudioProfile(WarpGunSwitchSound)
{
   filename    = "fx/weapons/sniper_activate.wav";
   description = AudioClosest3d;
   preload = true;
   effect = WarpGunSwitchEffect;
};

datablock AudioProfile(WarpGunTeleportSound)
{
   filename    = "fx/powered/vehicle_pad_on.wav";
   description = AudioClose3d;
   preload = true;
   effect = WarpGunTeleportEffect;
};

datablock AudioProfile(WarpGunFireSound)
{
   filename    = "fx/weapons/sniper_fire.wav";
   description = AudioClose3d;
   preload = true;
   effect = WarpGunFireEffect;
};

datablock AudioProfile(WarpGunFireWetSound)
{
   filename    = "fx/weapons/sniper_underwater.wav";
   description = AudioClose3d;
   preload = true;
   effect = WarpGunFireWetEffect;
};

datablock AudioProfile(WarpGunDryFireSound)
{
   filename    = "fx/weapons/chaingun_dryfire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(WarpGunProjectileSound)
{
   filename    = "fx/weapons/sniper_miss.wav";
   description = AudioClose3d;
   preload = true;
};

//-------------------------------------
// AMMO
//-------------------------------------
datablock ItemData(WarpGunAmmo)
{
   className = Ammo;
   catagory = "Ammo";
   shapeFile = "ammo_chaingun.dts";            //Energy Based now
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "some warp gun ammo";

   computeCRC = true;

};

//--------------------------------------
// Rifle and item...
//--------------------------------------
datablock ItemData(WarpGun)
{
   className    = Weapon;
   catagory     = "Spawn Items";
   shapeFile    = "stackable2s.dts";
   image        = WarpGunImage;
   mass         = 1;
   elasticity   = 0.2;
   friction     = 0.6;
   pickupRadius = 2;
	pickUpName = "a Teleportation Device";

   computeCRC = true;

};

datablock ShapeBaseImageData(WarpGunImage)
{
	className = WeaponImage;
   shapeFile = "stackable2s.dts";
   item = WarpGun;
   ammo = WarpGunAmmo;
   showname = "Warp Gun";

	usesEnergy = true;
	minEnergy = 1;

   stateName[0]                     = "Activate";
   stateTransitionOnTimeout[0]      = "ActivateReady";
   stateSound[0]                    = WarpGunSwitchSound;
   stateTimeoutValue[0]             = 0.5;
   stateSequence[0]                 = "Activate";

   stateName[1]                     = "ActivateReady";
   stateTransitionOnLoaded[1]       = "Ready";
   stateTransitionOnNoAmmo[1]       = "NoAmmo";

   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateTransitionOnTriggerDown[2]  = "CheckWet";

   stateName[3]                     = "Fire";
   stateTransitionOnTimeout[3]      = "Reload";
   stateTimeoutValue[3]             = 0.5;
   stateFire[3]                     = true;
   stateAllowImageChange[3]         = false;
   stateSequence[3]                 = "Fire";
   stateScript[3]                   = "onFire";

   stateName[4]                     = "Reload";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 1.0;
   stateAllowImageChange[4]         = false;

   stateName[5]                     = "CheckWet";
   stateTransitionOnWet[5]          = "DryFire";
   stateTransitionOnNotWet[5]       = "Fire";

   stateName[6]                     = "NoAmmo";
   stateTransitionOnAmmo[6]         = "Reload";
   stateTransitionOnTriggerDown[6]  = "DryFire";
   stateSequence[6]                 = "NoAmmo";

   stateName[7]                     = "DryFire";
   stateSound[7]                    = WarpGunDryFireSound;
   stateTimeoutValue[7]             = 0.5;
   stateTransitionOnTimeout[7]      = "Ready";
};

function WarpGunImage::onMount(%this,%obj,%slot)
{
    Parent::onMount(%this, %obj, %slot);
    commandToClient( %obj.client, 'BottomPrint', "<spush><font:Arial Black:20><color:ff3300>Teleportation Device<spop>\n<spush><font:Arial:14><color:ffcc00>Transports you to locations.. Cannot be by the flag to prevent capping<spop>\n<spush><font:arial:14><color:ff1100>Made By: Drumstix42<spop>", 3, 3);
}

function WarpGunImage::onFire(%data,%obj,%slot)
{
   %range = 9999; //Max range someone can warp to.
   %rangeFromFlag = 150; //Meters from enemy Flag must be to work. Prevents Flag Capping with WarpGun
   %radius = 0.5;
   %rot = getWords(%obj.getTransform(), 3, 6);
   %muzzlePos = %obj.getMuzzlePoint(%slot);
   %muzzleVec = %obj.getMuzzleVector(%slot);

   %endPos    = VectorAdd(%muzzlePos, VectorScale(%muzzleVec, %range));

   %damageMasks = $TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType |
                  $TypeMasks::StationObjectType | $TypeMasks::GeneratorObjectType |
                  $TypeMasks::SensorObjectType | $TypeMasks::TurretObjectType |
                  $TypeMasks::InteriorObjectType;

   %hit = ContainerRayCast(%muzzlePos, %endPos, %damageMasks | $TypeMasks::TerrainObjectType, %obj);
   %x2 = getWord(%hit, 1);
   %y2 = getWord(%hit, 2);
   %z2 = getWord(%hit, 3);
   if ((%hit) && (%z2 > 15))
   {
      %count = 0;
      %endpos = getWords(%hit.getWorldBoxCenter(), 0, 2);
      while (%count < 5)
      {
         %z2 += 2;
         %check1 = %x2 SPC %y2 SPC %z2;
         InitContainerRadiusSearch(%check1, %radius, %damageMasks);
         %checkok = 1;
         %targetObject = containerSearchNext();
         if (%targetObject)
            %count++;
         else
         {
            %checkok = 0;
            %count = 5;
         }
      }
      if (%checkok == 0)
      {
         if (%obj.team == 1)
            %team1 = 2;
         else
            %team1 = 1;
         %enemyFlag = $TeamFlag[%team1];
         if (isObject(%enemyFlag))
         {
            %dist = VectorDist(posfromTransform(%enemyFlag.getTransform()), %check1);
            %dist2 = VectorDist(posfromTransform(%enemyFlag.getTransform()), %obj.getMuzzlePoint(%slot));
            if ((%dist < %rangeFromFlag) || (%dist2 < %rangeFromFlag) || (%enemyFlag.carrier == %obj))
            {
               %checkok = 1;
               %checkok2 = 1;
               messageClient(%obj.client, 'msgBlocked', '\c1Interference from Flag.');
            }
         }
      }
      if (%checkok == 0)
      {
         if (%obj.getInventory( %data.ammo ) > 0)
         {
            %obj.setEnergyLevel(0);
            %newtrans = %check1 SPC %rot;
            %obj.setWhiteout(0.3);
            %obj.setVelocity("0 0 0");
            %obj.setTransform(%newtrans);
            %obj.decInventory(%data.ammo,0);       //hmmm
            %obj.playAudio(0, WarpGunTeleportSound);
         }
      }
      else if(%checkok2 != 1)
         messageClient(%obj.client, 'msgBlocked', '\c1target location is blocked.');
   }
   else
      messageClient(%obj.client, 'msgNothing', '\c1Cant find anything.');
}
